#2663 closed enhancement (wontfix)

pc386 BSP has complex dependencies

Reported by: Joel Sherrill Owned by: Sebastian Huber
Priority: normal Milestone: 5.1
Component: arch/i386 Version: 4.11
Severity: normal Keywords:
Cc: Chris Johns Blocked By:
Blocking:

Description

In 4.11, the minimum executable did not include open() and close() because the methods rtems_libio_post_driver() and rtems_libio_exit() were not included in the executable. On the master, these two methods are showing up in minimum and pulling in these methods.

The dependency chain used to be if the console driver was installed, we needed to open and close stdin, stdout, and stderr. Now even without the console configured these are included.

FWIW the minimum size looks pretty good on the master for sis. Fixing this would likely drop it at least another 5%.

Change History (12)

comment:1 Changed on Mar 21, 2016 at 6:47:24 AM by Sebastian Huber

This looks like a BSP-specific issue. On which BSP do you see this?

comment:2 Changed on Mar 21, 2016 at 6:50:32 AM by Chris Johns

SIS by the looks of "FWIW the minimum size looks pretty good on the master for sis. ...".

comment:3 Changed on Mar 21, 2016 at 6:52:49 AM by Sebastian Huber

Yes, but I don't see this problem on the sis BSP.

comment:4 Changed on Mar 21, 2016 at 7:41:18 AM by Sebastian Huber

It seems to be the pc386 BSP. It pulls in a lot of stuff via printk() (e.g. console_select.c).

comment:5 Changed on Mar 21, 2016 at 7:57:49 AM by Sebastian Huber

Component: RTEMS Configurationbsps
Type: defectenhancement
Version: 4.124.11

The pc386 BSP has this problem also in 4.11.

comment:6 Changed on Mar 21, 2016 at 7:59:24 AM by Sebastian Huber

Summary: Dependency on open() and close() reintroducedpc386 BSP has complex dependencies

comment:7 Changed on Mar 21, 2016 at 12:35:15 PM by Joel Sherrill

I saw this on sis. I was teaching a class and wouldn't use pc386 (or any BSP simulated on qemu) as my first choice since you want a simpler BSP and simpler way to execute it.

But I don't see it in sis minimum.exe now. I am going to close this.

comment:8 Changed on Mar 21, 2016 at 12:36:24 PM by Joel Sherrill

The pc386 and motorola_powerpc probe for a lot of features and don't have them as optional. They aren't focused on low size but flexibility. The pc386 can have the console changed by boot arguments and this is the intention. Most BSPs don't have that kind of flexibility.

comment:9 Changed on Mar 21, 2016 at 12:36:39 PM by Joel Sherrill

Resolution: wontfix
Status: newclosed

comment:10 Changed on May 11, 2017 at 7:31:02 AM by Sebastian Huber

Milestone: 4.124.12.0

comment:11 Changed on Oct 10, 2017 at 6:55:23 AM by Sebastian Huber

Component: bspsarch/i386

comment:12 Changed on Nov 9, 2017 at 6:27:14 AM by Sebastian Huber

Milestone: 4.12.05.1

Milestone renamed

Note: See TracTickets for help on using tickets.